package com.molino.mills.gui;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.JComponent;

import com.molino.mills.model.pos.XYBoardPosition;

/**
 * @author  Emilio
 */
public class BoardGridComponent extends JComponent
{
    /**
	 * @uml.property  name="dotSize"
	 */
    private int dotSize = 5;
    /**
	 * @uml.property  name="dotColor"
	 */
    private Color dotColor = Color.BLACK;
    /**
	 * @uml.property  name="lineColor"
	 */
    private Color lineColor = Color.BLACK;
 
    // private Dimension pieceSize;

    public BoardGridComponent()
    {
        super();
    }

    @Override
    protected void paintComponent(Graphics g)
    {
        Insets insets = getInsets();
        int xc = insets.left;
        int yc = insets.top;
        int size = Math.min(getWidth(), getHeight());
        int wc = size - insets.left - insets.right - 1;
        int hc = size - insets.top - insets.bottom - 1;
        
        g.setColor(lineColor);

        // Draw boxes

        g.drawRect(xc, yc, wc, hc);
        g.drawRect(xc + wc / 6, yc + hc / 6, wc * 4 / 6, hc * 4 / 6);
        g.drawRect(xc + wc * 2 / 6, yc + hc * 2 / 6, wc * 2 / 6, hc * 2 / 6);

        // Draw lines

        g.drawLine(xc, yc + hc * 3 / 6, xc + wc * 2 / 6, yc + hc * 3 / 6);
        g.drawLine(xc + wc * 4 / 6, yc + hc * 3 / 6, xc + wc, yc + hc * 3 / 6);
        g.drawLine(xc + wc * 3 / 6, yc, xc + wc * 3 / 6, yc + hc * 2 / 6);
        g.drawLine(xc + wc * 3 / 6, yc + hc * 4 / 6, xc + wc * 3 / 6, yc + hc);

        // Draw dots

        XYBoardPosition pos = new XYBoardPosition();
        g.setColor(dotColor);
        int xoffset = xc - (dotSize / 2);
        int yoffset = yc - (dotSize / 2);

        for (int i = 0; i <= 23; i++)
        {
            pos.setPosition(i);
            int x = (pos.getXPos() + 3) * wc / 6;
            int y = (pos.getYPos() + 3) * hc / 6;
            g.fillRect(x + xoffset, y + yoffset, dotSize, dotSize);
        }
        
        super.paintComponent(g);
    }
    
    /**
	 * @return
	 * @uml.property  name="dotSize"
	 */
    public int getDotSize()
    {
        return dotSize;
    }

    /**
	 * @param dotSize
	 * @uml.property  name="dotSize"
	 */
    public void setDotSize(int dotSize)
    {
        this.dotSize = dotSize;
    }

    /**
	 * @return
	 * @uml.property  name="dotColor"
	 */
    public Color getDotColor()
    {
        return dotColor;
    }

    /**
	 * @param dotColor
	 * @uml.property  name="dotColor"
	 */
    public void setDotColor(Color dotColor)
    {
        this.dotColor = dotColor;
    }

    /**
	 * @return
	 * @uml.property  name="lineColor"
	 */
    public Color getLineColor()
    {
        return lineColor;
    }

    /**
	 * @param lineColor
	 * @uml.property  name="lineColor"
	 */
    public void setLineColor(Color lineColor)
    {
        this.lineColor = lineColor;
    }
}