package com.molino.mills.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;

import javax.swing.JComponent;
import javax.swing.JPanel;

/**
 * @author  Emilio
 */
public class PieceComponent extends JComponent
{
    /**
	 * @uml.property  name="color"
	 */
    private Color color;
    /**
	 * @uml.property  name="position"
	 */
    private int position = -1;
    private Point homeLocation;
    private JPanel homePane;
    /**
	 * @uml.property  name="owner"
	 */
    private int owner;
    private static final Dimension DEFAULT_SIZE = new Dimension(17,17);
    
    public PieceComponent()
    {
        super();
        setPreferredSize(DEFAULT_SIZE);
        setSize(DEFAULT_SIZE);
        owner = -1;
   }
    
    public PieceComponent(Color color)
    {
        this();
        this.color = color;
    }

    @Override
    protected synchronized void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        int w = getWidth()-1;
        int h = getHeight()-1;

        if ( color!=null )
        {
            g.setColor(color);
            g.fillOval(0, 0, w, h);               
    
            if ( color.getRGB() > Color.GRAY.getRGB() )
            {
                g.setColor(Color.BLACK);
            } 
            else  
            {
                g.setColor(Color.GRAY);
            }
            
            g.drawOval(0, 0, w, h);
        }
    }

    /**
	 * @return
	 * @uml.property  name="color"
	 */
    public Color getColor()
    {
        return color;
    }

    /**
	 * @param color
	 * @uml.property  name="color"
	 */
    public synchronized void setColor(Color color)
    {
        this.color = color;
    }

    /**
	 * @return
	 * @uml.property  name="position"
	 */
    public int getPosition()
    {
        return position;
    }

    /**
	 * @param position
	 * @uml.property  name="position"
	 */
    public void setPosition(int position)
    {
        this.position = position;
    }


    public void addDragListener(DragListener dl)
    {
        addMouseMotionListener(dl);
        addMouseListener(dl);
    }

    /**
	 * @return
	 * @uml.property  name="owner"
	 */
    public int getOwner()
    {
        return owner;
    }

    /**
	 * @param owner
	 * @uml.property  name="owner"
	 */
    public void setOwner(int owner)
    {
        this.owner = owner;
    }
}
