package com.molino.mills.gui;
import java.awt.Color;
import java.awt.FlowLayout;

import javax.swing.JFrame;
import javax.swing.WindowConstants;

import com.molino.mills.model.Game;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial use. If Jigloo is being used commercially (ie, by a corporation, company or business for any purpose whatever) then you should purchase a license for each developer using Jigloo. Please visit www.cloudgarden.com for details. Use of Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class PiecePanel extends javax.swing.JPanel
{
    /**
	 * @uml.property  name="player"
	 */
    private int player;
    /**
	 * @uml.property  name="pieceDragListener"
	 * @uml.associationEnd  
	 */
    private PieceListener pieceDragListener;
    /**
	 * @uml.property  name="gameController"
	 * @uml.associationEnd  
	 */
    private GameController gameController;
    private FlowLayout thisLayout;
    
    /**
     * Auto-generated main method to display this JPanel inside a new JFrame.
     */
    public static void main(String[] args)
    {
        JFrame frame = new JFrame();
        frame.getContentPane().add(new PiecePanel());
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }

    public PiecePanel()
    {
        super();
        initGUI();
    }

    private void initGUI()
    {
        try
        {
            this.setPreferredSize(new java.awt.Dimension(400, 46));
            thisLayout = new FlowLayout();
            thisLayout.setAlignment(FlowLayout.LEFT);
            this.setLayout(thisLayout);

            this.setOpaque(false);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    public void refresh()
    {       
        Game game = getGame();
        if ( game==null )
            return;
        
        Color color = game.getPlayer(player).getColor();
        int pieces = game.state.board.unplacedPieces[player];

        while ( getComponentCount() > pieces )
        {
            remove(getComponentCount()-1);
        }

        while ( getComponentCount() < pieces ) 
        {
            PieceComponent pc = new PieceComponent(color);
            pc.setOwner(player);
            if ( pieceDragListener!=null )
                pc.addDragListener(pieceDragListener);
            add(pc);
        }    
    }

    public Game getGame()
    {
        return gameController==null?null : gameController.getCurrentGame();
    }

    /**
	 * @return
	 * @uml.property  name="player"
	 */
    public int getPlayer()
    {
        return player;
    }

    /**
	 * @param player
	 * @uml.property  name="player"
	 */
    public void setPlayer(int player)
    {
        this.player = player;
    }

    /**
	 * @return
	 * @uml.property  name="pieceDragListener"
	 */
    public PieceListener getPieceDragListener()
    {
        return pieceDragListener;
    }

    /**
	 * @param pieceDragListener
	 * @uml.property  name="pieceDragListener"
	 */
    public void setPieceDragListener(PieceListener pieceDragListener)
    {
        this.pieceDragListener = pieceDragListener;
    }

    /**
	 * @param gameController
	 * @uml.property  name="gameController"
	 */
    public void setGameController(GameController gameController)
    {
        this.gameController = gameController;        
    }
}
