package com.molino.mills.model;

public class BoardFeatures
{

    public int freebb;

    public int[] millbbs;

    public int[] millcnt;

    public int[] millposbbs;

    public static final int[][] MILL_POSITIONS = {


            { 0, 1, 2 }, { 2, 3, 4 }, { 4, 5, 6 }, { 6, 7, 0 },


            { 8, 9, 10 }, { 10, 11, 12 }, { 12, 13, 14 }, { 14, 15, 8 },


            { 16, 17, 18 }, { 18, 19, 20 }, { 20, 21, 22 }, { 22, 23, 16 },




            { 1, 9, 17 }, { 21, 13, 5 },


            { 7, 15, 23 }, { 19, 11, 3 } 
    };

    public static final int[] MILL_POSITION_BBS = BitBoardUtil.positionsArrayToBitBoards(MILL_POSITIONS);
    public static final int OUTER_RING_IDX = 0;
    public static final int MIDDLE_RING_IDX = 4;
    public static final int INNER_RING_IDX = 8;
    public static final int SPOKES_IDX = 12;
        
    public BoardFeatures(Board board)
    {
        freebb = BitBoardUtil.freeSpaces(board.bbs);
        detectMills(board);
    }

    protected void detectMills(Board board)
    {
        millbbs = new int[] { 0, 0 };
        millcnt = new int[] { 0, 0 };
        millposbbs = new int[] { 0, 0 };
        int bb0 = board.bbs[0];
        int bb1 = board.bbs[1];
        for (int i = 0; i < MILL_POSITION_BBS.length; i++)
        {
            int mask = MILL_POSITION_BBS[i];
            millposbbs[0]<<=1;
            millposbbs[1]<<=1;
            
            if ((bb0 & mask) == mask)
            {
                millbbs[0] |= mask;
                millcnt[0]++;
                millposbbs[0] |= 1;
            }

            if ((bb1 & mask) == mask)
            {
                millbbs[1] |= mask;
                millcnt[1]++;
                millposbbs[1] |= 1;
            }
        }
    }
}
