
package com.molino.mills.model.event;

import java.util.Formatter;
import java.util.Locale;

import com.molino.mills.model.Game;
import com.molino.mills.model.Player;
import com.molino.mills.model.move.CaptureMove;
import com.molino.mills.model.move.Move;
import com.molino.mills.model.move.MoveAndCaptureMove;

public class MoveEvent extends GameEvent
{
    /**
	 * @uml.property  name="move"
	 * @uml.associationEnd  
	 */
    private Move move;
    /**
	 * @uml.property  name="player"
	 * @uml.associationEnd  
	 */
    private Player player;
    /**
	 * @uml.property  name="turn"
	 */
    private int turn;

    public MoveEvent(Game game, int turn, Player player, Move move)
    {
        super(game);
        this.player = player;
        this.turn = turn;
        this.move = move;
    }

    /**
	 * @return
	 * @uml.property  name="move"
	 */
    public Move getMove()
    {
        return move;
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        Formatter fmt = new Formatter(sb, Locale.US);
        fmt.format("%1s. %2$s: %3$s", turn, player.getColorName(), move.toString());
        return sb.toString();
    }

    public void appendCaptureMove(CaptureMove captureMove)
    {
        move = new MoveAndCaptureMove(move, captureMove);
    }

    public void removeCaptureMove()
    {
        move = ((MoveAndCaptureMove) move).move;
    }
    
    /**
	 * @return
	 * @uml.property  name="player"
	 */
    public Player getPlayer()
    {
        return player;
    }

    /**
	 * @return
	 * @uml.property  name="turn"
	 */
    public int getTurn()
    {
        return turn;
    }
}
